/* kernel module sample program */

#include <linux/module.h>
#include <linux/fs.h>

static int sample_major = 0;
static char *devname= "sample";

static int sample_open(struct inode *inode, struct file *file) {
    printk("[sample] sample_open\n");
    return 0;
}

static int sample_release(struct inode *inode, struct file *file) {
    printk("[sample] sample_release\n");
    return 0;
}

static struct file_operations sample_fops = {
    .owner = THIS_MODULE,
    .open = sample_open,
    .release = sample_release
};

static int __init init_sample(void) {
    int result;

    printk("[sample] init_sample\n");

    result = register_chrdev(sample_major, devname, &sample_fops);
    if (result < 0) {
        printk("[sample] failed to register character device\n");
        return result;
    }

    if (sample_major == 0) {
        sample_major = result;
    }
    printk("[sample] successd to register (mojor number: %u)\n", result);

    return 0;
}

static void __exit exit_sample(void) {
    int result;

    result = unregister_chrdev(sample_major, devname);
    if (result < 0) {
        printk("[sample] failed to unregister character device\n");
    }
}

module_init(init_sample);
module_exit(exit_sample);
MODULE_LICENSE("GPL");

/* end of sample.c */
